#include "stdafx.h"
#include "3D.h"
#include "3DDoc.h"

IMPLEMENT_DYNCREATE(CMy3DDoc, CDocument)
BEGIN_MESSAGE_MAP(CMy3DDoc, CDocument)
END_MESSAGE_MAP()

CMy3DDoc::CMy3DDoc(): m_Line(NULL), m_nPt(0)
{
}

CMy3DDoc::~CMy3DDoc()
{
}

BOOL CMy3DDoc::OnNewDocument()
{
	if(!CDocument::OnNewDocument()) return FALSE;

	const int x=15,y=15,z=15, delta=100;
	int i,j,k, curpos=0;
	m_nPt=(x+y+2)*(z+1)+(x+1)*(y+1); m_Line=new C3dLine[m_nPt];
	for(k=0;k<=z;k++) {
		for(j=0;j<=y;j++)
			m_Line[curpos++]=C3dLine(0, j*delta, k*delta, x*delta, j*delta, k*delta);
		for(i=0;i<=x;i++)
			m_Line[curpos++]=C3dLine(i*delta, 0, k*delta, i*delta, y*delta, k*delta);
	}
	for(j=0;j<=y;j++)
		for(i=0;i<=x;i++)
			m_Line[curpos++]=C3dLine(i*delta, j*delta, 0, i*delta, j*delta, z*delta);
	return TRUE;
}

#ifdef _DEBUG
void CMy3DDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMy3DDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

BOOL CMy3DDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	int i; FILE *fp; if(!CDocument::OnOpenDocument(lpszPathName)) return FALSE;
	fp=_tfopen(lpszPathName, _T("rt")); if(!fp) return FALSE;
	_ftscanf(fp, _T("%d\n"), &i); if(i<=0 || i>=65536) { m_nPt=0; fclose(fp); return FALSE; }
	m_nPt=i; m_Line=new C3dLine[m_nPt];
	for(i=0;i<m_nPt;i++) {
		//%f for float, %lf for double
		_ftscanf(fp, _T("%lf %lf %lf %lf %lf %lf\n"), &m_Line[i].from.x, &m_Line[i].from.y,
			&m_Line[i].from.z, &m_Line[i].to.x, &m_Line[i].to.y, &m_Line[i].to.z);
/*#define FFF 0.1
		m_Line[i].from.x*=FFF; m_Line[i].from.y*=FFF; m_Line[i].from.z*=FFF;
		m_Line[i].to.x*=FFF; m_Line[i].to.y*=FFF; m_Line[i].to.z*=FFF;*/
	}
	fclose(fp); return TRUE;
}

BOOL CMy3DDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	int i; if(!CDocument::OnSaveDocument(lpszPathName)) return FALSE;
	FILE *fp; fp=_tfopen(lpszPathName, _T("wt")); VERIFY(fp);
	if(!fp) return FALSE;
	_ftprintf(fp, _T("%d\n"), m_nPt);
	for(i=0;i<m_nPt;i++) {
		_ftprintf(fp, _T("%g %g %g %g %g %g\n"), m_Line[i].from.x, m_Line[i].from.y, m_Line[i].from.z,
			m_Line[i].to.x, m_Line[i].to.y, m_Line[i].to.z);
	}
	fclose(fp); return TRUE;
}

void CMy3DDoc::DeleteContents() 
{
	delete []m_Line; m_Line=NULL; CDocument::DeleteContents();
}
