#include "stdafx.h"
#include "3D.h"
#include "MainFrm.h"

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)
BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	ON_WM_CREATE()
	ON_WM_INITMENU()
END_MESSAGE_MAP()

const UINT CMainFrame::m_nIndicators[]={
	ID_SEPARATOR // status line indicator
};

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME)) return -1;

	if (!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(m_nIndicators,
		  sizeof(m_nIndicators)/sizeof(UINT))) return -1;

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY); DockControlBar(&m_wndToolBar);
	DragAcceptFiles();
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	CRect rect(0,0,530,550); // ǿ â  ۰
	if(::GetSystemMetrics(SM_REMOTESESSION)) rect.right-=150, rect.bottom-=150;
	::AdjustWindowRectEx(rect, cs.style, TRUE, cs.dwExStyle);
	cs.cx=rect.Width(); cs.cy=rect.Height();
	if(!CMDIFrameWnd::PreCreateWindow(cs)) return FALSE;
	return TRUE;
}

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

#include "3dView.h"
void CMainFrame::OnInitMenu(CMenu* pMenu) 
{
	if(CWnd::GetFocus()->IsKindOf(RUNTIME_CLASS(CMy3DView))) CMy3DView::InitKeyInfo();
	CMDIFrameWnd::OnInitMenu(pMenu);
}
